import java.awt.*;

public class DrawingAircraft {
    protected EntityAircraft entityAircraft ;
    protected void setEntityShip(EntityAircraft  entityShip){
        this.entityAircraft  = entityAircraft;
    }
    public EntityAircraft getEntityShip() {
        return entityAircraft;
    }
    private IDrawImprovements drawingImprovements;
    private int _pictureWidth;
    private int _pictureHeight;
    protected int _startPosX;
    public int getPosX(){
        return _startPosX;
    }
    protected int _startPosY;
    public int getPosY(){
        return _startPosY;
    }
    private final int _ShipWidth = 164;
    public int getWidth() {
        return _ShipWidth;
    }
    private final int _ShipHeight = 40;
    public int getHeight(){
        return _ShipHeight;
    }
    public DrawingAircraft(int speed, double weight, Color bodyColor, int width, int height, int improvementsType, int improvementsNumber) {
        if (width < _ShipWidth || height < _ShipHeight)
            return;
        _pictureWidth = width;
        _pictureHeight = height;
        entityAircraft = new EntityAircraft(speed, weight, bodyColor);
        switch (improvementsType){
            case 1:
                drawingImprovements = new DrawingImprovementsSquare();
                break;
            case 2:
                drawingImprovements = new DrawingImprovementsCircle();
                break;
            default:
                drawingImprovements = new DrawingImprovementsTriangle();
                break;
        }
        drawingImprovements.setNumber(improvementsNumber);
    }
    public void setPosition(int x, int y)
    {
        if (_startPosX > (_pictureWidth - _ShipWidth) || _startPosY>(_pictureHeight - _ShipHeight) || x <= 0 || y <= 0)
            x = y = 2;
        _startPosX = x;
        _startPosY = y;
    }
    public void drawTransport(Graphics2D g) {
        if (entityAircraft == null)
            return;
        Color penColor = Color.BLACK;
        Color bodyColor = entityAircraft.getBodyColor();
        g.setColor(penColor);
        g.drawLine(_startPosX+4, _startPosY, _startPosX + 124, _startPosY);
        g.drawLine(_startPosX+124, _startPosY, _startPosX + 164, _startPosY+20);
        g.drawLine(_startPosX + 164, _startPosY+20, _startPosX + 124, _startPosY + 40);
        g.drawLine(_startPosX + 164, _startPosY + 20, _startPosX + 124, _startPosY + 40);
        g.drawLine(_startPosX + 124, _startPosY + 40, _startPosX + 4, _startPosY + 40);
        g.drawLine(_startPosX+4, _startPosY + 40, _startPosX + 4, _startPosY);
        g.setColor(bodyColor);
        g.fillRect(_startPosX, _startPosY + 6, 4, 12);
        g.fillRect(_startPosX, _startPosY + 24, 4, 12);
        g.setColor(penColor);
        g.drawOval(_startPosX + 115, _startPosY + 13, 14, 14);
        g.drawRect(_startPosX + 63, _startPosY + 13, 27, 14);
        g.drawRect(_startPosX + 90, _startPosY + 9, 14, 22);
        g.setColor(bodyColor);
        drawingImprovements.drawImprovements(g, _startPosX, _startPosY);
    }
    public boolean canMove(DirectionType direction) {
        if (entityAircraft == null) {
            return false;
        }
        switch(direction) {
            case LEFT:
                return _startPosX - entityAircraft.step.get().intValue() > 0;
            case UP:
                return _startPosY - entityAircraft.step.get().intValue() > 0;
            case RIGHT:
                return _startPosX + entityAircraft.step.get().intValue() + _ShipWidth < _pictureWidth;
            case DOWN:
                return _startPosY + entityAircraft.step.get().intValue() + _ShipWidth < _pictureWidth;
            default:
                return false;
        }
    }
    public void moveTransport(DirectionType direction)
    {
        if (entityAircraft == null)
            return;
        int step = entityAircraft.step.get().intValue();
        switch (direction)
        {
            case LEFT:
                if (_startPosX - step > 0)
                    _startPosX -= step;
                break;
            case UP:
                if (_startPosY - step > 0)
                    _startPosY -= step;
                break;
            case RIGHT:
                if (_startPosX + _ShipWidth + step < _pictureWidth)
                    _startPosX += step;
                break;
            case DOWN:
                if (_startPosY + _ShipHeight + step < _pictureHeight)
                    _startPosY += step;
                break;
        }
    }
}
