
import java.awt.*;

public class DrawingAircraftCarrier extends DrawingAircraft {
    public DrawingAircraftCarrier(int speed, double weight, Color bodyColor,
                            Color additionalColor, boolean cabin, boolean runway, int width, int height, int improvementsType, int improvementsNumber){
        super(speed, weight, bodyColor, width, height, improvementsType, improvementsNumber);
        if(entityAircraft != null)
            entityAircraft = new EntityAircraftCarrier(speed, weight, bodyColor, additionalColor,cabin, runway);
    }
    public void drawTransport(Graphics2D g)
    {
        if (!(entityAircraft instanceof EntityAircraftCarrier))
            return;
        EntityAircraftCarrier entityAircraftCarrier = (EntityAircraftCarrier) entityAircraft;
        Color additionalColor = entityAircraftCarrier.getAdditionalColor();
        super.drawTransport(g);
        if(entityAircraftCarrier.getRunway()){
            g.setColor(additionalColor);
            g.fillRect(_startPosX + 4, _startPosY + 13, 59, 14);
            g.setColor(Color.WHITE);
            g.drawLine(_startPosX + 62, _startPosY + 19, _startPosX + 52, _startPosY + 19);
            g.drawLine(_startPosX + 47, _startPosY + 19, _startPosX + 37, _startPosY + 19);
            g.drawLine(_startPosX + 32, _startPosY + 19, _startPosX + 22, _startPosY + 19);
            g.drawLine(_startPosX + 17, _startPosY + 19, _startPosX + 7, _startPosY + 19);
        }
        if (entityAircraftCarrier.getCabin())
        {
            g.setColor(additionalColor);
            g.fillRect(_startPosX + 90, _startPosY, 15, 9);
        }
    }
}